## python3.6 3.6.5

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python3
VENVDIR      = ./venv
SPHINXBUILD  = PATH=$(VENVDIR)/bin:$$PATH sphinx-build
BLURB        = PATH=$(VENVDIR)/bin:$$PATH blurb
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/extensions/patchlevel.py)

ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees -D latex_elements.papersize=$(PAPER) \
                $(SPHINXOPTS) . build/$(BUILDER) $(SOURCES)

.PHONY: help build html htmlhelp latex text changes linkcheck \
	suspicious coverage doctest pydoc-topics htmlview clean dist check serve \
	autobuild-dev autobuild-stable venv

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  venv       to create a venv with necessary tools"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlview   to open the index page built by the html target in your browser"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  epub       to make EPUB files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  suspicious to check for suspicious markup in output text"
	@echo "  check      to run a check for frequent markup errors"
	@echo "  serve      to serve the documentation on the localhost (8000)"

build:
	-mkdir -p build
# Look first for a Misc/NEWS file (building from a source release tarball
# or old repo) and use that, otherwise look for a Misc/NEWS.d directory
# (building from a newer repo) and use blurb to generate the NEWS file.
	@if [ -f  ../Misc/NEWS ] ; then \
		echo "Using existing Misc/NEWS file"; \
		cp ../Misc/NEWS build/NEWS; \
	elif [ -d ../Misc/NEWS.d ]; then \
		echo "Building NEWS from Misc/NEWS.d with blurb"; \
		$(BLURB) merge -f build/NEWS; \
	else \
		echo "Neither Misc/NEWS.d nor Misc/NEWS found; cannot build docs"; \
		exit 1; \
	fi
	$(SPHINXBUILD) $(ALLSPHINXOPTS)
	@echo

html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

epub: BUILDER = epub
epub: build
	@echo "Build finished; the epub files are in build/epub."

changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

linkcheck: BUILDER = linkcheck
linkcheck:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Link check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/output.txt"; \
	false; }

suspicious: BUILDER = suspicious
suspicious:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Suspicious check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
	     "positives, append that file to tools/susp-ignored.csv."; \
	false; }

coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

doctest: BUILDER = doctest
doctest:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Testing of doctests in the sources finished, look at the" \
	     "results in build/doctest/output.txt"; \
	false; }

pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now run this:" \
	      "cp build/pydoc-topics/topics.py ../Lib/pydoc_data/topics.py"

htmlview: html
	 $(PYTHON) -c "import webbrowser; webbrowser.open('build/html/index.html')"

clean:
	-rm -rf build/* $(VENVDIR)/*

venv:
	$(PYTHON) -m venv $(VENVDIR)
	$(VENVDIR)/bin/python3 -m pip install -U Sphinx blurb
	@echo "The venv has been created in the $(VENVDIR) directory"

dist:
	rm -rf dist
	mkdir -p dist

	# archive the HTML
	make html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar

	# archive the text build
	make text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar

	# archive the A4 latex
	rm -rf build/latex
	make latex PAPER=a4
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2

	# archive the letter latex
	rm -rf build/latex
	make latex PAPER=letter
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2

	# copy the epub build
	rm -rf build/epub
	make epub
	cp -pPR build/epub/Python.epub dist/python-$(DISTVERSION)-docs.epub

check:
	$(PYTHON) tools/rstlint.py -i tools -i $(VENVDIR) -i README.rst

serve:
	../Tools/scripts/serve.py build/html

# Targets for daily automated doc build
# By default, Sphinx only rebuilds pages where the page content has changed.
# This means it doesn't always pick up changes to preferred link targets, etc
# To ensure such changes are picked up, we build the published docs with
# `-E` (to ignore the cached environment) and `-a` (to ignore already existing
# output files)

# for development releases: always build
autobuild-dev:
	make dist SPHINXOPTS='$(SPHINXOPTS) -Ea -A daily=1 -A switchers=1'
	-make suspicious

# for quick rebuilds (HTML only)
autobuild-dev-html:
	make html SPHINXOPTS='$(SPHINXOPTS) -Ea -A daily=1 -A switchers=1'

# for stable releases: only build if not in pre-release stage (alpha, beta)
# release candidate downloads are okay, since the stable tree can be in that stage
autobuild-stable:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev

autobuild-stable-html:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev-html

=== debian/changelog ===
python3.6 (3.6.5-3) unstable; urgency=medium

  * Fix library name in the python debug pkgconfig file. Closes: #894498.

 -- Matthias Klose <doko@debian.org>  Sun, 01 Apr 2018 13:46:30 +0800

python3.6 (3.6.5-2) unstable; urgency=medium

  * libpython3.6-stdlib: Add missing python3-distutils breaks. Closes: #894204.

 -- Matthias Klose <doko@debian.org>  Sat, 31 Mar 2018 06:34:57 +0100

python3.6 (3.6.5-1) unstable; urgency=medium

  * Python 3.6.5 release.

 -- Matthias Klose <doko@debian.org>  Fri, 30 Mar 2018 10:08:52 +0800

python3.6 (3.6.5~rc1-3) unstable; urgency=medium

  * libpython3.6-stdlib: Ship again distutils/{__init__,version}.py.

 -- Matthias Klose <doko@debian.org>  Thu, 22 Mar 2018 10:45:39 +0000

python3.6 (3.6.5~rc1-2) unstable; urgency=medium

  * python3.6: Drop dependency on python3-distutils.
  * Fix issue #32305, libregrtest regression when backporting issue #32305.
    Closes: #890621, #890844.

 -- Matthias Klose <doko@debian.org>  Tue, 20 Mar 2018 14:29:58 +0800

=== debian/control ===
Source: python3.6
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.11),
  quilt, autoconf,
  lsb-release, sharutils,
  libreadline-dev, libncursesw5-dev (>= 5.3), 
  zlib1g-dev, libbz2-dev, liblzma-dev,
  libgdbm-dev, libdb-dev,
  tk-dev, blt-dev (>= 2.4z), libssl-dev,
  libexpat1-dev, libmpdec-dev (>= 2.4),
  libbluetooth-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  locales [!armel !avr32 !hppa !ia64 !mipsel],
  libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
  libgpm2 [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  mime-support, netbase, bzip2, time, python3:any,
  net-tools, xvfb, xauth
Build-Depends-Indep: python3-sphinx, texinfo
Standards-Version: 4.1.3
Vcs-Browser: https://code.launchpad.net/~doko/python/pkg3.6-debian
Vcs-Bzr: http://bazaar.launchpad.net/~doko/python/pkg3.6-debian
XS-Testsuite: autopkgtest

Package: python3.6
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.6-minimal (= ${binary:Version}),
 libpython3.6-stdlib (= ${binary:Version}),
 mime-support,
 ${shlibs:Depends}, ${misc:Depends}
Suggests: python3.6-venv, python3.6-doc, binutils
Description: Interactive high-level object-oriented language (version 3.6)
 Python is a high-level, interactive, object-oriented language. Its 3.6 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python3.6-venv
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.6 (= ${binary:Version}),
 python-pip-whl (>= 8.1.0-2), ${shlibs:Depends}, ${misc:Depends},
Breaks: python3-pip (<< 1.5.6-4)
Description: Interactive high-level object-oriented language (pyvenv binary, version 3.6)
 Python is a high-level, interactive, object-oriented language. Its 3.6 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the pyvenv-3.6 binary.

Package: libpython3.6-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.6-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Breaks: python3-tk (<< 3.6.4~rc1-2),
  python3-distutils (<< 3.6.5-2),
  libmpdec2 (<< 2.4.2), cython3 (<< 0.26-2.1), python3-lxml (<< 3.8.0-2), python3-numpy (<< 1:1.12.1-3.1), python3-tk (<< 3.6.2-1~), python3-scipy (<< 0.18.1-2.1), borgbackup (<= 1.0.11-3), python3-acora (<= 2.0-2+b1), python3-adios (<= 1.12.0-3), python3-astroml-addons (<= 0.2.2-4), python3-astropy (<= 2.0.1-2), python3-astroscrappy (<= 1.0.5-1+b1), python3-asyncpg (<= 0.12.0-1), python3-bcolz (<= 1.1.0+ds1-4+b1), python3-brainstorm (<= 0.5-3+b1), python3-cartopy (<= 0.14.2+dfsg1-2+b1), python3-cutadapt (<= 1.13-1+b1), python3-djvu (<= 0.8-2), python3-fabio (<= 0.4.0+dfsg-2+b1), python3-falcon (<= 1.0.0-2+b1), python3-fiona (<= 1.7.9-1), python3-grib (<= 2.0.2-2), python3-gssapi (<= 1.2.0-1+b1), python3-h5py (<= 2.7.0-1+b1), python3-healpy (<= 1.10.3-2+b1), python3-kivy (<= 1.9.1-1+b1), python3-libdiscid (<= 1.0-1+b1), python3-liblo (<= 0.10.0-3+b1), python3-llfuse (<= 1.2+dfsg-1+b1), python3-ltfatpy (<= 1.0.9-1), python3-netcdf4 (<= 1.2.9-1+b1), python3-pandas-lib (<= 0.20.3-1), python3-petsc4py (<= 3.7.0-3+b1), python3-pybedtools (<= 0.7.8-1), python3-pyfai (<= 0.13.0+dfsg-1+b1), python3-pygpu (<= 0.6.9-2), python3-pymca5 (<= 5.1.3+dfsg-1+b1), python3-pymssql (<= 2.1.3+dfsg-1+b1), python3-pyresample (<= 1.5.0-3+b1), python3-pysam (<= 0.11.2.2+ds-3), python3-pywt (<= 0.5.1-1.1+b1), python3-rasterio (<= 0.36.0-2+b2), python3-sfml (<= 2.2~git20150611.196c88+dfsg-4), python3-shapely (<= 1.6.1-1), python3-skbio (<= 0.5.1-2+b1), python3-skimage-lib (<= 0.12.3-9+b1), python3-sklearn-lib (<= 0.19.0-1), python3-specutils (<= 0.2.2-1+b1), python3-stemmer (<= 1.3.0+dfsg-1+b7), python3-tables-lib (<= 3.3.0-5+b1), python3-tinycss (<= 0.4-1+b1), python3-wheezy.template (<= 0.1.167-1.1+b1), python3-yt (<= 3.3.3-2+b1), 
Replaces: libpython3.6-testsuite (<< 3.6.2-2),
  python3-distutils (<< 3.6.5-2),
Description: Interactive high-level object-oriented language (standard library, version 3.6)
 Python is a high-level, interactive, object-oriented language. Its 3.6 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains Python 3.6's standard library. It is normally not
 used on its own, but as a dependency of python3.6.

Package: python3.6-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: ${shlibs:Pre-Depends}
Depends: libpython3.6-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.6
Suggests: binfmt-support
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.6)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python3.6-minimal/README.Debian for a list of the modules
 contained in this package.

Package: libpython3.6-minimal
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libpython3.6-stdlib
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.6)
 This package contains some essential modules. It is normally not
 used on it's own, but as a dependency of python3.6-minimal.

Package: libpython3.6
Architecture: any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.6-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Shared Python runtime library (version 3.6)
 Python is a high-level, interactive, object-oriented language. Its 3.6 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python3.6-examples
Architecture: all
Multi-Arch: foreign
Depends: python3.6:any (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v3.6)
 Examples, Demos and Tools for Python (v3.6). These are files included in
 the upstream Python distribution (v3.6).

Package: python3.6-dev
Architecture: any
Multi-Arch: allowed
Depends: python3.6 (= ${binary:Version}), libpython3.6-dev (= ${binary:Version}), libpython3.6 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.6)
 Header files, a static library and development tools for building
 Python (v3.6) modules, extending the Python interpreter or embedding
 Python (v3.6) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: libpython3.6-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.6-stdlib (= ${binary:Version}), libpython3.6 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.6)
 Header files, a static library and development tools for building
 Python (v3.6) modules, extending the Python interpreter or embedding
 Python (v3.6) in applications.
 .
 Maintainers of Python packages should read README.maintainers.
 .
 This package contains development files. It is normally not
 used on it's own, but as a dependency of python3.6-dev.

Package: libpython3.6-testsuite
Section: libdevel
Architecture: all
Depends: python3.6 (>= ${binary:Version}), ${misc:Depends}, net-tools
Suggests: python3-gdbm, python3-tk
Description: Testsuite for the Python standard library (v3.6)
 The complete testsuite for the Python standard library.  Note that
 a subset is found in the libpython3.6-stdlib package, which should
 be enough for other packages to use (please do not build-depend
 on this package, but file a bug report to include additional 
 testsuite files in the libpython3.6-stdlib package).

Package: idle-python3.6
Architecture: all
Depends: python3.6, python3-tk, python3.6-tk, ${misc:Depends}
Enhances: python3.6
Breaks: libpython3.6-stdlib (<< 3.6.3-2)
Replaces: libpython3.6-stdlib (<< 3.6.3-2)
Description: IDE for Python (v3.6) using Tkinter
 IDLE is an Integrated Development Environment for Python (v3.6).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python3.6-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python3.6
Description: Documentation for the high-level object-oriented language Python (v3.6)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v3.6). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python3.6
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python3.6-dbg
Section: debug
Architecture: any
Multi-Arch: allowed
Depends: python3.6 (= ${binary:Version}), libpython3.6-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gdb
Suggests: python3-gdbm-dbg, python3-tk-dbg
Description: Debug Build of the Python Interpreter (version 3.6)
 The package holds two things:
 .
 - A Python interpreter configured with --pydebug. Dynamically loaded modules
   are searched as <foo>_d.so first. Third party extensions need a separate
   build to be used by this interpreter.
 - Debug information for standard python interpreter and extensions.
 .
 See the README.debug for more information.

Package: libpython3.6-dbg
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.6-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Debug Build of the Python Interpreter (version 3.6)
 The package holds two things:
 .
 - Extensions for a Python interpreter configured with --pydebug.
 - Debug information for standard python extensions.
 .
 See the README.debug for more information.

=== debian/rules ===
#!/usr/bin/make -f

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS

export DEB_BUILD_MAINT_OPTIONS=hardening=-pie
export DEB_BUILD_MAINT_OPTIONS=hardening=-pie
DEB_BUILD_MAINT_OPTIONS := hardening=-pie
export DEB_BUILD_MAINT_OPTIONS

#DEB_MAINT_BUILD_OPTIONS := hardening=-pie
#export DEB_MAINT_BUILD_OPTIONS

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt		= $(subst $(2)=,,$(filter $(2)=%,$(1)))
DPKG_VARS	:= $(shell dpkg-architecture)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_ENDIAN	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

ifeq ($(DEB_HOST_ARCH_OS),linux)
  PLAT = linux
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
  PLAT = gnukfreebsd10
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
  PLAT = gnu0
else
  $(warning unhandled operating system name: $(DEB_HOST_ARCH_OS))
  PLAT = unknown
endif

CHANGELOG_VARS := $(shell dpkg-parsechangelog | \
	sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE  := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)

LAST_CHANGE := $(shell dpkg-parsechangelog -S Date)
export BUILD_DATE := $(shell LC_ALL=C date -u +'%b %e %Y' -d '$(LAST_CHANGE)')
export BUILD_TIME := $(shell LC_ALL=C date -u +'%H:%M:%S' -d '$(LAST_CHANGE)')

SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
export SPHINXOPTS

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

dh_compat2 := $(shell dpkg --compare-versions "$$(dpkg-query -f '$${Version}' -W debhelper)" lt 9.20150811ubuntu2 && echo DH_COMPAT=2)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_CHECK := yes
  endif
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_BENCH := yes
    WITHOUT_STONE := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
  WITHOUT_STONE := yes
endif

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distribution := Debian
distrelease  := $(shell lsb_release -cs)
distrelease  := sid
derivative := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
		elif dpkg-vendor --derives-from Debian; then echo Debian; \
		else echo Unknown; fi)

VER=3.6
SVER=3.6.4~rc1
NVER=3.7
PVER=python$(VER)
EXT_VER=$(subst .,,$(VER))
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
else
  PY_PRIO = optional
endif
ifeq ($(distribution),Ubuntu)
  PY_MINPRIO = required
  PY_MINPRIO = optional
  #with_udeb = yes
else
  PY_MINPRIO = $(PY_PRIO)
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifneq (,$(filter $(distrelease),sid experimental))
  bd_gcc =
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif

CC=$(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

DPKG_CPPFLAGS:= $(shell dpkg-buildflags --get CPPFLAGS)
DPKG_CFLAGS  = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=-pie dpkg-buildflags --get CFLAGS)
DPKG_LDFLAGS := $(shell DEB_BUILD_MAINT_OPTIONS=hardening=-pie dpkg-buildflags --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-Og,$(DPKG_CFLAGS))

# on alpha, use -O2 only, use -mieee
ifeq ($(DEB_HOST_ARCH),alpha)
    OPT_CFLAGS += -mieee
    DEBUG_CFLAGS += -mieee
    EXTRA_OPT_FLAGS += -O2
endif
ifeq ($(DEB_HOST_ARCH),m68k)
    EXTRA_OPT_FLAGS += -O2
endif
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
    OPT_CFLAGS += -fexceptions
    DEBUG_CFLAGS += -fexceptions
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
      with_pgo := yes
    endif
  endif
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
  with_lto := yes
endif

ifeq ($(distribution),Debian)
  # FIXME: https://buildd.debian.org/status/logs.php?pkg=python3.5&ver=3.5.1-1&arch=s390x&suite=sid
  with_lto := $(if $(filter $(DEB_HOST_ARCH), s390x),,$(with_lto))
endif

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS))
    EXTRA_OPT_CFLAGS = -O0
    with_pgo =
    with_lto =
endif

    with_pgo =
    with_lto =

ifeq ($(with_lto),yes)
    LTO_CFLAGS = -g -flto -fuse-linker-plugin
    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
    ifeq ($(with_fat_lto),yes)
      LTO_CFLAGS += -ffat-lto-objects
    endif
    EXTRA_OPT_CFLAGS += $(LTO_CFLAGS)
    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
endif

make_build_target = $(if $(with_pgo),profile-opt)

buildd_static	:= $(CURDIR)/build-static
buildd_shared	:= $(CURDIR)/build-shared
buildd_debug	:= $(CURDIR)/build-debug
buildd_shdebug	:= $(CURDIR)/build-shdebug

d		:= debian/tmp
scriptdir	=  usr/share/lib/python$(VER)
scriptdir	=  usr/share/python$(VER)
scriptdir	=  usr/lib/python$(VER)

# package names and directories
p_base	:= $(PVER)
p_min	:= $(PVER)-minimal
p_lib	:= lib$(PVER)
p_tk	:= $(PVER)-tk
p_dev	:= $(PVER)-dev
p_exam	:= $(PVER)-examples
p_idle	:= idle-$(PVER)
p_doc	:= $(PVER)-doc
p_dbg	:= $(PVER)-dbg
p_udeb	:= $(PVER)-udeb
p_venv	:= $(PVER)-venv

p_lbase	:= lib$(PVER)-stdlib
p_lmin	:= lib$(PVER)-minimal
p_ldev	:= lib$(PVER)-dev
p_ldbg	:= lib$(PVER)-dbg
p_ltst	:= lib$(PVER)-testsuite

d_base	:= debian/$(p_base)
d_min	:= debian/$(p_min)

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential, locales, python3.6-dev, libpython3.6-testsuite, python3-gdbm, python3-distutils
# need to turn off apport
Restrictions: needs-root

Tests: testsuite-dbg
Depends: build-essential, locales, python3.6-dev, python3.6-dbg, libpython3.6-testsuite, python3-gdbm-dbg, gdb, python3-distutils
# need to turn off apport
Restrictions: needs-root

Tests: failing-tests
Depends: build-essential, locales, python3.6-dev, libpython3.6-testsuite, python3-gdbm, python3-distutils
# need to turn off apport
Restrictions: needs-root allow-stderr

Tests: failing-tests-dbg
Depends: build-essential, locales, python3.6-dev, python3.6-dbg, libpython3.6-testsuite, python3-gdbm-dbg, gdb, python3-distutils
# need to turn off apport
Restrictions: needs-root allow-stderr

## python3.6 3.6.7~rc1

=== debian/changelog ===
python3.6 (3.6.7~rc1-1) unstable; urgency=medium

  * Python 3.6.7 release candidate 1.

 -- Matthias Klose <doko@debian.org>  Thu, 27 Sep 2018 11:51:25 +0200

python3.6 (3.6.6-4) unstable; urgency=medium

  * Update to 20180901 from the 3.6 branch.
  * Add idle-python3.6 to the autopkg test depends.

 -- Matthias Klose <doko@debian.org>  Sat, 01 Sep 2018 03:05:25 +0200

python3.6 (3.6.6-3) unstable; urgency=medium

  * Update to 20180828 from the 3.6 branch.
  * Disable running some tests which are not ready for Debian's OpenSSL
    defaults (test_{asyncio,ftplib,httplib,imaplib,nntplib,poplib,ssl}).
    Closes: #907215.

 -- Matthias Klose <doko@debian.org>  Tue, 28 Aug 2018 11:10:57 +0200

python3.6 (3.6.6-2) unstable; urgency=medium

  * Update to 20180820 from the 3.6 branch.
  * Avoid usage of distutils in the platform module. See issue #26544.
  * Move test/__main__.py into libpython3.6-stdlib.
  * Pass the list of the pyFPE breaks as a parameter into dpkg-gencontrol
    instead of hard-coding them in the control file.

 -- Matthias Klose <doko@debian.org>  Mon, 20 Aug 2018 18:21:04 +0200

python3.6 (3.6.6-1) unstable; urgency=medium

  * Python 3.6.6 release.

 -- Matthias Klose <doko@debian.org>  Wed, 27 Jun 2018 16:44:17 +0200

python3.6 (3.6.6~rc1-4) unstable; urgency=medium

  * Update to 20180622 from the 3.6 branch.
    - Fix installation of idlelib testsuite.

 -- Matthias Klose <doko@debian.org>  Fri, 22 Jun 2018 10:07:48 +0200

python3.6 (3.6.6~rc1-3) unstable; urgency=medium

  * Update to 20180619 from the 3.6 branch.
  * Let ensurepip work with pip versions 9 or 10. Closes: #901797.
  * pdb(1): Fix pointer to HTML documentation. Closes: #901603.

 -- Matthias Klose <doko@debian.org>  Fri, 15 Jun 2018 12:13:28 +0200

python3.6 (3.6.6~rc1-1) unstable; urgency=medium

  * Python 3.6.6 release candidate 1.

 -- Matthias Klose <doko@debian.org>  Wed, 13 Jun 2018 08:59:48 +0200

python3.6 (3.6.5-10) unstable; urgency=medium

  * Update to 20180608 from the 3.6 branch.
  * Update the the sysconfig-debian-schemes patch, not yet applied.
    sysconfig: The 'posix_local' schema name is the default unless the env var
    DEB_PYTHON_INSTALL_LAYOUT is set to 'deb' or 'deb_system'.  Use the latter
    for package buillds.
  * Build cmath as a builtin instead of an extension.
  * Run the test_code_module, test_zipfile tests in the autopkg tests again.
  * Build using GCC 8.

 -- Matthias Klose <doko@debian.org>  Fri, 08 Jun 2018 23:55:12 +0200

python3.6 (3.6.5-9) unstable; urgency=medium

  * python3.6: Add breaks on python3-all (<< 3.6.5~rc1-1),
    python3-dev (<< 3.6.5~rc1-1), python3-venv (<< 3.6.5-2). Closes: #898401.

 -- Matthias Klose <doko@debian.org>  Fri, 11 May 2018 09:30:17 -0400

python3.6 (3.6.5-8) unstable; urgency=medium

  * Fix the lto build for extensions, passing -fPIC to the linker.

 -- Matthias Klose <doko@debian.org>  Mon, 07 May 2018 19:24:55 +0200

python3.6 (3.6.5-6) unstable; urgency=medium

  * Don't inject dpkg's compiler specs into distutils. LP: #1768644.

 -- Matthias Klose <doko@debian.org>  Thu, 03 May 2018 13:49:03 +0200

python3.6 (3.6.5-5) unstable; urgency=medium

  * Fix the lto build on x86_64 architectures.
  * Make the build of the shared modules verbose again.

 -- Matthias Klose <doko@debian.org>  Mon, 30 Apr 2018 15:54:44 +0200

python3.6 (3.6.5-4) unstable; urgency=medium

  * Re-enable pgo/lto builds.

 -- Matthias Klose <doko@debian.org>  Mon, 30 Apr 2018 07:47:20 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.11),
   quilt, autoconf,
   lsb-release, sharutils,
-  libreadline-dev, libncursesw5-dev (>= 5.3), 
+  libreadline-dev, libncursesw5-dev (>= 5.3), g++-8,
   zlib1g-dev, libbz2-dev, liblzma-dev,
   libgdbm-dev, libdb-dev,
   tk-dev, blt-dev (>= 2.4z), libssl-dev,
@@ -17,7 +17,7 @@
   mime-support, netbase, bzip2, time, python3:any,
   net-tools, xvfb, xauth
 Build-Depends-Indep: python3-sphinx, texinfo
-Standards-Version: 4.1.3
+Standards-Version: 4.2.1
 Vcs-Browser: https://code.launchpad.net/~doko/python/pkg3.6-debian
 Vcs-Bzr: http://bazaar.launchpad.net/~doko/python/pkg3.6-debian
 XS-Testsuite: autopkgtest
@@ -31,6 +31,9 @@
  mime-support,
  ${shlibs:Depends}, ${misc:Depends}
 Suggests: python3.6-venv, python3.6-doc, binutils
+Breaks: python3-all (<< 3.6.5~rc1-1),
+  python3-dev (<< 3.6.5~rc1-1),
+  python3-venv (<< 3.6.5-2)
 Description: Interactive high-level object-oriented language (version 3.6)
  Python is a high-level, interactive, object-oriented language. Its 3.6 version
  includes an extensive class library with lots of goodies for
@@ -58,8 +61,9 @@
 Depends: libpython3.6-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
 Breaks: python3-tk (<< 3.6.4~rc1-2),
   python3-distutils (<< 3.6.5-2),
-  libmpdec2 (<< 2.4.2), cython3 (<< 0.26-2.1), python3-lxml (<< 3.8.0-2), python3-numpy (<< 1:1.12.1-3.1), python3-tk (<< 3.6.2-1~), python3-scipy (<< 0.18.1-2.1), borgbackup (<= 1.0.11-3), python3-acora (<= 2.0-2+b1), python3-adios (<= 1.12.0-3), python3-astroml-addons (<= 0.2.2-4), python3-astropy (<= 2.0.1-2), python3-astroscrappy (<= 1.0.5-1+b1), python3-asyncpg (<= 0.12.0-1), python3-bcolz (<= 1.1.0+ds1-4+b1), python3-brainstorm (<= 0.5-3+b1), python3-cartopy (<= 0.14.2+dfsg1-2+b1), python3-cutadapt (<= 1.13-1+b1), python3-djvu (<= 0.8-2), python3-fabio (<= 0.4.0+dfsg-2+b1), python3-falcon (<= 1.0.0-2+b1), python3-fiona (<= 1.7.9-1), python3-grib (<= 2.0.2-2), python3-gssapi (<= 1.2.0-1+b1), python3-h5py (<= 2.7.0-1+b1), python3-healpy (<= 1.10.3-2+b1), python3-kivy (<= 1.9.1-1+b1), python3-libdiscid (<= 1.0-1+b1), python3-liblo (<= 0.10.0-3+b1), python3-llfuse (<= 1.2+dfsg-1+b1), python3-ltfatpy (<= 1.0.9-1), python3-netcdf4 (<= 1.2.9-1+b1), python3-pandas-lib (<= 0.20.3-1), python3-petsc4py (<= 3.7.0-3+b1), python3-pybedtools (<= 0.7.8-1), python3-pyfai (<= 0.13.0+dfsg-1+b1), python3-pygpu (<= 0.6.9-2), python3-pymca5 (<= 5.1.3+dfsg-1+b1), python3-pymssql (<= 2.1.3+dfsg-1+b1), python3-pyresample (<= 1.5.0-3+b1), python3-pysam (<= 0.11.2.2+ds-3), python3-pywt (<= 0.5.1-1.1+b1), python3-rasterio (<= 0.36.0-2+b2), python3-sfml (<= 2.2~git20150611.196c88+dfsg-4), python3-shapely (<= 1.6.1-1), python3-skbio (<= 0.5.1-2+b1), python3-skimage-lib (<= 0.12.3-9+b1), python3-sklearn-lib (<= 0.19.0-1), python3-specutils (<= 0.2.2-1+b1), python3-stemmer (<= 1.3.0+dfsg-1+b7), python3-tables-lib (<= 3.3.0-5+b1), python3-tinycss (<= 0.4-1+b1), python3-wheezy.template (<= 0.1.167-1.1+b1), python3-yt (<= 3.3.3-2+b1), 
-Replaces: libpython3.6-testsuite (<< 3.6.2-2),
+  libpython3.6-testsuite (<< 3.6.6-2),
+  libmpdec2 (<< 2.4.2), ${pyfpe:Breaks}
+Replaces: libpython3.6-testsuite (<< 3.6.6-2),
   python3-distutils (<< 3.6.5-2),
 Description: Interactive high-level object-oriented language (standard library, version 3.6)
  Python is a high-level, interactive, object-oriented language. Its 3.6 version

=== debian/rules ===
--- 
+++ 
@@ -4,12 +4,7 @@
 unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=-pie
-export DEB_BUILD_MAINT_OPTIONS=hardening=-pie
-DEB_BUILD_MAINT_OPTIONS := hardening=-pie
-export DEB_BUILD_MAINT_OPTIONS
-
-#DEB_MAINT_BUILD_OPTIONS := hardening=-pie
-#export DEB_MAINT_BUILD_OPTIONS
+dpkg_buildflags = DEB_BUILD_MAINT_OPTIONS=$(DEB_BUILD_MAINT_OPTIONS) dpkg-buildflags
 
 export SHELL = /bin/bash
 
@@ -90,7 +85,7 @@
 		else echo Unknown; fi)
 
 VER=3.6
-SVER=3.6.4~rc1
+SVER=3.6.5
 NVER=3.7
 PVER=python$(VER)
 EXT_VER=$(subst .,,$(VER))
@@ -155,13 +150,19 @@
 
 CC=$(DEB_HOST_GNU_TYPE)-gcc
 CXX=$(DEB_HOST_GNU_TYPE)-g++
+ifneq (,$(filter $(distrelease),sid buster bionic cosmic))
+  CC=$(DEB_HOST_GNU_TYPE)-gcc-8
+  CXX=$(DEB_HOST_GNU_TYPE)-g++-8
+  bd_gcc = g++-8,
+endif
 
 AR=$(DEB_HOST_GNU_TYPE)-ar
 RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib
 
-DPKG_CPPFLAGS:= $(shell dpkg-buildflags --get CPPFLAGS)
-DPKG_CFLAGS  = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=-pie dpkg-buildflags --get CFLAGS)
-DPKG_LDFLAGS := $(shell DEB_BUILD_MAINT_OPTIONS=hardening=-pie dpkg-buildflags --get LDFLAGS)
+DPKG_CPPFLAGS= $(shell $(dpkg_buildflags) --get CPPFLAGS)
+DPKG_CFLAGS  := $(shell $(dpkg_buildflags) --get CFLAGS)
+DPKG_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_CFLAGS))
+DPKG_LDFLAGS = $(shell $(dpkg_buildflags) --get LDFLAGS)
 OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
 DEBUG_CFLAGS := $(patsubst -O%,-Og,$(DPKG_CFLAGS))
 
@@ -202,9 +203,6 @@
     with_pgo =
     with_lto =
 endif
-
-    with_pgo =
-    with_lto =
 
 ifeq ($(with_lto),yes)
     LTO_CFLAGS = -g -flto -fuse-linker-plugin
@@ -218,36 +216,26 @@
     RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
 endif
 
+sysconfig_substflags = \
+	-e 's,gcc-8,gcc,;s,g++-8,g++,' \
+	-e '/^OPT/s,-O3,-O2,' \
+	-e 's/-O3/-O2/g;s/$(LTO_CFLAGS)//g' \
+	-e 's/-fprofile-use *-fprofile-correction//g' \
+	-e 's/-fstack-protector /-fstack-protector-strong /g' \
+	-e 's/-specs=[^ ]*//g' \
+	-e 's/-fdebug-prefix-map=[^ ]*//g' \
+	-e 's,^RUNSHARED *=.*,RUNSHARED=,' \
+	-e '/BLDLIBRARY/s/-L\. //'
+
+ifneq ($(with_fpectl),yes)
+  ifeq ($(derivative),Ubuntu)
+    arch_substvars =  '-Vpyfpe:Breaks=$(shell tr '\n' ' ' < debian/pyfpe-breaks.$(derivative))'
+  else ifeq ($(derivative),Debian)
+    arch_substvars =  '-Vpyfpe:Breaks=$(shell tr '\n' ' ' < debian/pyfpe-breaks.$(derivative))'
+  endif
+endif
+
 make_build_target = $(if $(with_pgo),profile-opt)
 
 buildd_static	:= $(CURDIR)/build-static
 buildd_shared	:= $(CURDIR)/build-shared
-buildd_debug	:= $(CURDIR)/build-debug
-buildd_shdebug	:= $(CURDIR)/build-shdebug
-
-d		:= debian/tmp
-scriptdir	=  usr/share/lib/python$(VER)
-scriptdir	=  usr/share/python$(VER)
-scriptdir	=  usr/lib/python$(VER)
-
-# package names and directories
-p_base	:= $(PVER)
-p_min	:= $(PVER)-minimal
-p_lib	:= lib$(PVER)
-p_tk	:= $(PVER)-tk
-p_dev	:= $(PVER)-dev
-p_exam	:= $(PVER)-examples
-p_idle	:= idle-$(PVER)
-p_doc	:= $(PVER)-doc
-p_dbg	:= $(PVER)-dbg
-p_udeb	:= $(PVER)-udeb
-p_venv	:= $(PVER)-venv
-
-p_lbase	:= lib$(PVER)-stdlib
-p_lmin	:= lib$(PVER)-minimal
-p_ldev	:= lib$(PVER)-dev
-p_ldbg	:= lib$(PVER)-dbg
-p_ltst	:= lib$(PVER)-testsuite
-
-d_base	:= debian/$(p_base)
-d_min	:= debian/$(p_min)

## python3.6 3.6.7

=== debian/changelog ===
python3.6 (3.6.7-1~18.04) bionic-proposed; urgency=medium

  * SRU: LP: #1799206.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Oct 2018 13:32:17 +0200

python3.6 (3.6.7-1) unstable; urgency=medium

  * Python 3.6.7 release.

 -- Matthias Klose <doko@debian.org>  Sun, 21 Oct 2018 10:08:16 +0200

python3.6 (3.6.7~rc2-1) unstable; urgency=medium

  * Python 3.6.7 release candidate 2.

 -- Matthias Klose <doko@debian.org>  Mon, 15 Oct 2018 11:34:57 +0200

python3.6 (3.6.6-1~18.04) bionic-proposed; urgency=medium

  * SRU: LP: #1792143. Update Python 3.6 to the recent subminor release.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 12 Sep 2018 20:26:19 +0200

## python3.6 3.6.8

=== debian/changelog ===
python3.6 (3.6.8-1~18.10) cosmic-proposed; urgency=medium

  * PPA upload.
  * SRU: LP: #1822993. Update to the 3.6.8 release.
  * d/p/arm-alignment.diff: Don't allow unaligned memory accesses in the
    _sha3 extension (Dave Jones). LP: #1821869. Issue #36515.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 09 Apr 2019 06:59:38 +0200

python3.6 (3.6.8-1) unstable; urgency=medium

  * Python 3.6.8 release.
  * Revert the link optimization changes which appeared after the
    release candidate.

 -- Matthias Klose <doko@debian.org>  Thu, 03 Jan 2019 04:42:36 +0100

python3.6 (3.6.8~rc1-1) unstable; urgency=medium

  * Python 3.6.8 release candidate 1.
  * Update symbols files.

 -- Matthias Klose <doko@debian.org>  Wed, 12 Dec 2018 07:12:40 +0100

python3.6 (3.6.7-1~18.10) cosmic-proposed; urgency=medium

  * SRU: LP: #1799206.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Oct 2018 13:32:17 +0200

## python3.6 3.6.9

=== debian/changelog ===
python3.6 (3.6.9-1~18.04ubuntu1.12) bionic-security; urgency=medium

  * SECURITY UPDATE: Possible Bypass Blocklisting
    - debian/patches/CVE-2023-24329.patch: enforce
      that a scheme must begin with an alphabetical ASCII character
      in Lib/urllib/parse.py, Lib/test/test_urlparse.py.
    - CVE-2023-24329

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Fri, 10 Mar 2023 13:46:00 -0300

python3.6 (3.6.9-1~18.04ubuntu1.10) bionic-security; urgency=medium

  * SECURITY UPDATE: Buffer overflow in SHA3 (Keccak)
    - debian/patches/CVE-2022-37454.patch: fix a buffer overflow in
      Modules/_sha3/kcp/KeccakSponge.inc, Lib/test/test_hashlib.py
     (LP: #1995197).
    - CVE-2022-37454

 -- Dimitri John Ledkov <dimitri.ledkov@canonical.com>  Tue, 28 Feb 2023 09:55:20 +0000

python3.6 (3.6.9-1~18.04ubuntu1.9) bionic-security; urgency=medium

  * SECURITY UPDATE: Denial of service
    - debian/patches/CVE-2022-45061.patch: fix quadratic time idna decoding
      in Lib/encodings/idna.py, Lib/test/test_codecs.py.
    - CVE-2022-45061

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Fri, 25 Nov 2022 11:10:45 -0300

python3.6 (3.6.9-1~18.04ubuntu1.8) bionic-security; urgency=medium

  * SECURITY UPDATE: Injection Attack
    - debian/patches/CVE-2015-20107.patch: Make mailcap refuse to match unsafe
      filenames/types/param in Lib/mailcap.py, Lib/test/test_mailcap.py.
    - CVE-2015-20107

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Wed, 29 Jun 2022 08:45:57 -0300

python3.6 (3.6.9-1~18.04ubuntu1.7) bionic-security; urgency=medium

  * SECURITY UPDATE: Expose sensitive information
    - debian/patches/CVE-2021-3426.patch: remove pydoc getfile feature
      in Lib/pydoc.py, Lib/test/test_pydoc.py.
    - CVE-2021-3426
  * SECURITY UPDATE: Expose sensitive information
    - debian/patches/CVE-2021-4189.patch: alters ftplib.FTP class
      behavior to not trust the IPv4 address sent from the remote
      server when setting up a passive data channel in
      resposne in Lib/ftplib.py, Lib/test/test_ftplib.py.
    - CVE-2021-4189
  * SECURITY UPDATE: Injection Attack
    - debian/patches/CVE-2022-0391.patch: sanitize urls in urllib.parse
      when it containing ASCII newline and tabs in
      Doc/library/urllib.parse.rst, Lib/test/test_urlparse.py,
      Lib/urllib/parse.py.
    - CVE-2022-0391

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Tue, 15 Mar 2022 10:55:28 -0300

python3.6 (3.6.9-1~18.04ubuntu1.6) bionic-security; urgency=medium

  * SECURITY UPDATE: Regular Expression Denial of Service
     - debian/patches/CVE-2021-3733.patch: updates a regular expression in the 
       urllib.request.AbstractBasicAuthHandler class which has a quadratic
       worst-case time complexity and could be abused by a malicious HTTP
       server to cause a Denial of Service condition for a client.
     - CVE-2021-3733 
  * SECURITY UPDATE: Denial of Service
     - debian/patches/CVE-2021-3737.patch: addresses the potential for the
       urllib http client to enter into an infinite loop and hang on a 100
       Continue response from a malicious server.
     - debian/patches/CVE-2021-3737_test-fix.patch: improves the regression
       test in Lib/test/test_httplib.py
     - CVE-2021-3737 

 -- Ian Constantin <ian.constantin@canonical.com>  Wed, 08 Dec 2021 16:08:43 -0500

python3.6 (3.6.9-1~18.04ubuntu1.4) bionic-security; urgency=medium

  * SECURITY UPDATE: Code execution from content received via HTTP
    - debian/patches/CVE-2020-27619-3.6.patch: no longer call eval() on
      content received via HTTP in Lib/test/multibytecodec_support.py.
    - CVE-2020-27619
  * SECURITY UPDATE: Buffer overflow
    - debian/patches/CVE-2021-3177-3.6.patch: replace snprintf with Python unicode
      formatting in ctypes param reprs in Lib/ctypes/test/test_parameters.py,
      Modules/_ctypes/callproc.c.
    - CVE-2021-3177

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Tue, 26 Jan 2021 12:33:00 -0300

python3.6 (3.6.9-1~18.04ubuntu1.3) bionic-security; urgency=medium

  * SECURITY UPDATE: CRLF injection
    - debian/patches/CVE-2020-26116.patch: prevent header injection
      in http methods in Lib/httplib.py, Lib/test/test_httlib.py.
    - CVE-2020-26116
  * debian/patches/disabling_test_ttk_guionly.patch: disabling ttk_guionly
    test which is causing a hang for ppc64el build.

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Thu, 08 Oct 2020 09:12:24 -0300

python3.6 (3.6.9-1~18.04ubuntu1.1) bionic-security; urgency=medium

  * SECURITY UPDATE: Misleading information
    - debian/patches/CVE-2019-17514.patch: explain that the orderness of the
      of the result is system-dependant in Doc/library/glob.rst.
    - CVE-2019-17514
  * SECURITY UPDATE: Denial of service
    - debian/patches/CVE-2019-9674.patch: add pitfalls to
      zipfile module doc in Doc/library/zipfile.rst,
      Misc/NEWS.d/next/Documentation/2019-06-04-09-29-00.bpo-36260.WrGuc-.rst.
    - CVE-2019-9674
  * SECURITY UPDATE: Infinite loop
    - debian/patches/CVE-2019-20907.patch: avoid infinite loop in the
      tarfile module in Lib/tarfile.py, Lib/test/test_tarfile.py and add
      Lib/test/recursion.tar binary for test.
    - CVE-2019-20907
  * SECURITY UPDATE: Denial of service
    - debian/patches/CVE-2020-14422.patch: Resolve hash collisions for
      IPv4Interface and IPv6Interface in Lib/ipaddress.py,
      Lib/test/test_ipaddress.py.
    - CVE-2020-14422

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Fri, 17 Jul 2020 09:50:27 -0300

python3.6 (3.6.9-1~18.04ubuntu1) bionic-security; urgency=medium

  * SECURITY UPDATE: CRLF injection
    - debian/patches/CVE-2019-18348.patch: disallow control characters
      in hostnames in http.client in Lib/http/client.py, Lib/test/test_urllib.py.
    - CVE-2019-18348
  * SECURITY UPDATE: Denial of service
    - debian/patches/CVE-2020-8492.patch: fix the regex to prevent


=== debian/control ===
--- 
+++ 
@@ -18,8 +18,8 @@
   net-tools, xvfb, xauth
 Build-Depends-Indep: python3-sphinx, texinfo
 Standards-Version: 4.2.1
-Vcs-Browser: https://code.launchpad.net/~doko/python/pkg3.6-debian
-Vcs-Bzr: http://bazaar.launchpad.net/~doko/python/pkg3.6-debian
+Vcs-Browser: https://salsa.debian.org/cpython-team/python3/tree/python3.6
+Vcs-Git: https://salsa.debian.org/cpython-team/python3.git -b python3.6
 XS-Testsuite: autopkgtest
 
 Package: python3.6

=== debian/rules ===
--- 
+++ 
@@ -188,7 +188,7 @@
   endif
 endif
 
-ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
+ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
   with_lto := yes
 endif

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential, locales, python3.6-dev, libpython3.6-testsuite, python3-gdbm, python3-distutils, python3-tk, idle-python3.6
# need to turn off apport
Restrictions: needs-root

Tests: testsuite-dbg
Depends: build-essential, locales, python3.6-dev, python3.6-dbg, libpython3.6-testsuite, python3-gdbm-dbg, gdb, python3-distutils, python3-tk-dbg, idle-python3.6
# need to turn off apport
Restrictions: needs-root

Tests: failing-tests
Depends: build-essential, locales, python3.6-dev, libpython3.6-testsuite, python3-gdbm, python3-distutils, idle-python3.6
# need to turn off apport
Restrictions: needs-root allow-stderr

Tests: failing-tests-dbg
Depends: build-essential, locales, python3.6-dev, python3.6-dbg, libpython3.6-testsuite, python3-gdbm-dbg, gdb, python3-distutils, idle-python3.6
# need to turn off apport
Restrictions: needs-root allow-stderr

=== debian/watch ===
version=3
opts=dversionmangle=s/.*\+//,uversionmangle=s/([abcr]+[1-9])$/~$1/ \
  http://www.python.org/ftp/python/3\.6(\.\d)?/Python-(3\.6[.\dabcr]*)\.tgz
